Index: trunk/src/lib/parser/preferences/preferences.cc
===================================================================
--- trunk/src/lib/parser/preferences/preferences.cc	(revision 9869)
+++ trunk/src/lib/parser/preferences/preferences.cc	(revision 9869)
@@ -0,0 +1,335 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+#include "preferences.h"
+#include "lib/parser/ini_parser/ini_parser.h"
+#include "debug.h"
+
+ObjectListDefinition(Preferences);
+
+/**
+ * standard constructor
+ */
+Preferences::Preferences ()
+{
+  this->registerObject(this, Preferences::_objectList);
+   this->setName("Preferences");
+   this->fileName = "";
+}
+
+/**
+ *  the singleton reference to this class
+ */
+Preferences* Preferences::singletonRef = NULL;
+
+/**
+   @brief standard deconstructor
+ */
+Preferences::~Preferences ()
+{
+  Preferences::singletonRef = NULL;
+}
+
+/**
+ * Check if this item exists
+ * @param section name of the section
+ * @param name name of the item to check
+ * @return true if the item exists
+ */
+bool Preferences::exists( const std::string& section, const std::string& name)
+{
+  std::list<prefSection>::const_iterator it = data.begin();
+
+  for ( ; it!=data.end(); it++)
+  {
+    if ( it->sectionName == section )
+    {
+      std::list<prefItem>::const_iterator it2 = it->items.begin();
+
+      for ( ; it2!=it->items.end(); it2++)
+      {
+        if ( it2->name == name )
+          return true;
+      }
+
+      break;
+    }
+  }
+
+  return false;
+}
+
+/**
+ * Check if this section exists
+ * @param section name of the section
+ * @param name name of the item to check
+ * @return true if the item exists
+ */
+bool Preferences::sectionExists( const std::string& section )
+{
+  std::list<prefSection>::const_iterator it = data.begin();
+
+  for ( ; it!=data.end(); it++)
+  {
+    if ( it->sectionName == section )
+    {
+      return true;
+    }
+  }
+
+  return false;
+}
+
+/**
+ * Sets the value of an item. Creates it if doesn't exits.
+ * @param section name of the section
+ * @param name name of the item
+ * @param value value
+ */
+void Preferences::setString(const std::string& section, const std::string& name, const std::string& value, bool dontSetModified)
+{
+  MultiType t(value);
+  setMultiType(section, name, t, dontSetModified);
+}
+
+/**
+ * Sets the value of an item. Creates it if doesn't exits.
+ * @param section name of the section
+ * @param name name of the item
+ * @param value value
+ */
+void Preferences::setInt(const std::string& section, const std::string& name, int value, bool dontSetModified)
+{
+  MultiType t(value);
+  setMultiType(section, name, t, dontSetModified);
+}
+
+/**
+ * Sets the value of an item. Creates it if doesn't exits.
+ * @param section name of the section
+ * @param name name of the item
+ * @param value value
+ */
+void Preferences::setFloat(const std::string& section, const std::string& name, float value, bool dontSetModified)
+{
+  MultiType t(value);
+  setMultiType(section, name, t, dontSetModified);
+}
+
+/**
+ * Get the value of an item
+ * @param section name of the section
+ * @param name name of the item to check
+ * @param defaultValue value to return if item doesn't exist
+ * @return value of the item if found. defaultValue else
+ */
+std::string Preferences::getString(const std::string& section, const std::string& name, const std::string& defaultValue)
+{
+  return getMultiType(section, name, MultiType(defaultValue)).getString();
+}
+
+/**
+ * Get the value of an item
+ * @param section name of the section
+ * @param name name of the item to check
+ * @param defaultValue value to return if item doesn't exist
+ * @return value of the item if found. defaultValue else
+ */
+int Preferences::getInt(const std::string& section, const std::string& name, int defaultValue)
+{
+  return getMultiType(section, name, MultiType(defaultValue)).getInt();
+}
+
+/**
+ * Get the value of an item
+ * @param section name of the section
+ * @param name name of the item to check
+ * @param defaultValue value to return if item doesn't exist
+ * @return value of the item if found. defaultValue else
+ */
+float Preferences::getFloat(const std::string& section, const std::string& name, float defaultValue)
+{
+  return getMultiType(section, name, MultiType(defaultValue)).getFloat();
+}
+
+/**
+ * Sets the value of an item. Creates it if doesn't exits.
+ * @param section name of the section
+ * @param name name of the item
+ * @param value value
+ */
+void Preferences::setMultiType(const std::string& section, const std::string& name, const MultiType& value, bool dontSetModified)
+{
+  std::list<prefSection>::iterator it = data.begin();
+
+  for ( ; it!=data.end(); it++)
+  {
+    if ( it->sectionName == section )
+    {
+      std::list<prefItem>::iterator it2 = it->items.begin();
+
+      for ( ; it2!=it->items.end(); it2++)
+      {
+        if ( it2->name == name )
+        {
+          if (!dontSetModified)
+            it2->modified = value.getString() != it2->value.getString();
+
+          it2->value = value;
+
+          return;
+        }
+      }
+      prefItem item;
+      item.value = value;
+      item.modified = !dontSetModified;
+      item.name = name;
+      it->items.push_back(item);
+      return;
+    }
+  }
+
+  prefItem item;
+  item.value = value;
+  item.modified = !dontSetModified;
+  item.name = name;
+
+  prefSection sec;
+  sec.items.push_back(item);
+  sec.sectionName = section;
+  data.push_back( sec );
+}
+
+/**
+ * Get the value of an item
+ * @param section name of the section
+ * @param name name of the item to check
+ * @param defaultValue value to return if item doesn't exist
+ * @return value of the item if found. defaultValue else
+ */
+MultiType Preferences::getMultiType(const std::string& section, const std::string& name,const MultiType& defaultValue)
+{
+  std::list<prefSection>::const_iterator it = data.begin();
+
+  for ( ; it!=data.end(); it++)
+  {
+    if ( it->sectionName == section )
+    {
+      std::list<prefItem>::const_iterator it2 = it->items.begin();
+
+      for ( ; it2!=it->items.end(); it2++)
+      {
+        if ( it2->name == name )
+        {
+          return it2->value;
+        }
+      }
+
+      break;
+    }
+  }
+
+  return defaultValue;
+}
+
+void Preferences::setUserIni(const std::string& fileName)
+{
+  this->fileName = fileName;
+}
+
+bool Preferences::save()
+{
+  if ( this->fileName == "" )
+  {
+    PRINTF(1)("You must call setUserIni before you can call save()\n");
+    return false;
+  }
+  IniParser iniParser(this->fileName);
+
+  std::list<prefSection>::iterator it = data.begin();
+  bool didChanges = false;
+  for ( ; it!=data.end(); it++)
+  {
+    std::list<prefItem>::iterator it2 = it->items.begin();
+
+    for ( ; it2!=it->items.end(); it2++)
+    {
+      if ( it2->modified )
+      {
+        iniParser.editVar(it2->name, it2->value.getString(), it->sectionName);
+        didChanges = true;
+      }
+    }
+  }
+  /// HACK DO WE HAVE TO CHECK THIS??
+  //if ( didChanges )
+  {
+    iniParser.writeFile( this->fileName );
+  }
+
+  return true;
+}
+
+/**
+ * prints out all section with its items and values
+ */
+void Preferences::debug()
+{
+  std::list<prefSection>::iterator it = data.begin();
+
+  for ( ; it!=data.end(); it++)
+  {
+    PRINTF(0)("%s\n", it->sectionName.c_str());
+    std::list<prefItem>::iterator it2 = it->items.begin();
+
+    for ( ; it2!=it->items.end(); it2++)
+    {
+      PRINTF(0)("--> %s = '%s'%s\n", it2->name.c_str(), it2->value.getString().c_str(), ((!it2->modified)?"":" <modified>"));
+    }
+  }
+}
+
+/**
+ * list all keys in section
+ * @param section section
+ * @return list of keys
+ */
+std::list< std::string > Preferences::listKeys( const std::string section )
+{
+  std::list<std::string> lst;
+
+  std::list<prefSection>::const_iterator it = data.begin();
+
+  for ( ; it!=data.end(); it++)
+  {
+    if ( it->sectionName == section )
+    {
+      std::list<prefItem>::const_iterator it2 = it->items.begin();
+
+      for ( ; it2!=it->items.end(); it2++)
+      {
+        lst.push_back( it2->name );
+      }
+
+      break;
+    }
+  }
+
+  return lst;
+}
+
+
Index: trunk/src/lib/parser/preferences/preferences.h
===================================================================
--- trunk/src/lib/parser/preferences/preferences.h	(revision 9869)
+++ trunk/src/lib/parser/preferences/preferences.h	(revision 9869)
@@ -0,0 +1,72 @@
+/*!
+ * @file proto_singleton.h
+ * @brief Definition of the ... singleton Class
+*/
+
+#ifndef _PREFERENCES_H
+#define _PREFERENCES_H
+
+#include "base_object.h"
+#include "multi_type.h"
+#include <list>
+
+// FORWARD DECLARATION
+
+class IniFilePrefsReader;
+
+typedef struct {
+  std::string name;
+  MultiType value;
+  bool modified;
+} prefItem;
+
+typedef struct {
+  std::string sectionName;
+  std::list<prefItem> items;
+} prefSection ;
+
+
+//! A default singleton class.
+class Preferences : public BaseObject {
+  ObjectListDeclaration(Preferences);
+ public:
+   virtual ~Preferences(void);
+  /** @returns a Pointer to the only object of this Class */
+   inline static Preferences* getInstance(void) { if (!singletonRef) singletonRef = new Preferences();  return singletonRef; };
+
+   //check if this entry exists
+   bool sectionExists(const std::string& section );
+   bool exists(const std::string& section, const std::string& name);
+
+   void setString(const std::string& section, const std::string& name, const std::string& value, bool dontSetModified = false);
+   void setInt(const std::string& section, const std::string& name, int value, bool dontSetModified = false);
+   void setFloat(const std::string& section, const std::string& name, float value, bool dontSetModified = false);
+   void setMultiType(const std::string& section, const std::string& name, const MultiType& value, bool dontSetModified = false);
+
+   std::string getString(const std::string& section, const std::string& name, const std::string& defaultValue);
+   int getInt(const std::string& section, const std::string& name, int defaultValue);
+   float getFloat(const std::string& section, const std::string& name, float defaultValue);
+   MultiType getMultiType(const std::string& section, const std::string& name, const MultiType& defaultValue);
+
+   void setUserIni(const std::string& fileName);
+
+   bool save();
+
+   void debug();
+
+   std::list<std::string> listKeys( const std::string section );
+
+
+ private:
+   Preferences(void);
+   static Preferences* singletonRef;
+
+   std::list<prefSection> data;
+
+   std::list<IniFilePrefsReader*> iniFilePrefsReaders;
+
+   std::string fileName;
+
+};
+
+#endif /* _PREFERENCES_H */
Index: trunk/src/lib/physics/fields/field.cc
===================================================================
--- trunk/src/lib/physics/fields/field.cc	(revision 9682)
+++ trunk/src/lib/physics/fields/field.cc	(revision 9869)
@@ -23,7 +23,8 @@
 #include "util/loading/load_param.h"
 
+ObjectListDefinition(Field);
 
 /**
- *  standard constructor
+ * @brief standard constructor
 */
 Field::Field ()
@@ -33,7 +34,6 @@
 
 /**
- *  standard deconstructor
-
-*/
+ * @brief standard deconstructor
+ */
 Field::~Field ()
 {
@@ -42,9 +42,9 @@
 
 /**
-  \brief initializes a Field
-*/
+  * @brief initializes a Field
+ */
 void Field::init()
 {
-  this->setClassID(CL_FIELD, "Field");
+  this->registerObject(this, Field::_objectList);
   this->setMagnitude(1);
   this->setAttenuation(0);
@@ -54,5 +54,5 @@
 
 /**
-* @param root The XML-element to load settings from
+ * @param root The XML-element to load settings from
  */
 void Field::loadParams(const TiXmlElement* root)
Index: trunk/src/lib/physics/fields/field.h
===================================================================
--- trunk/src/lib/physics/fields/field.h	(revision 9682)
+++ trunk/src/lib/physics/fields/field.h	(revision 9869)
@@ -16,9 +16,9 @@
 /*!
  * @file field.h
-  *  abstract definition of a Physical Field
-
-    This is a totally abstract class, that only enables different Physical Fields to
-    exist on a common Level.
-*/
+ * abstract definition of a Physical Field
+ *
+ * This is a totally abstract class, that only enables different Physical Fields to
+ * exist on a common Level.
+ */
 
 #ifndef _FIELD_H
@@ -34,4 +34,5 @@
 class Field : public PNode
 {
+  ObjectListDeclaration(Field);
  public:
   Field();
Index: trunk/src/lib/physics/fields/gravity.cc
===================================================================
--- trunk/src/lib/physics/fields/gravity.cc	(revision 9682)
+++ trunk/src/lib/physics/fields/gravity.cc	(revision 9869)
@@ -21,11 +21,12 @@
 #include "util/loading/factory.h"
 
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Gravity, CL_FIELD_GRAVITY);
 
-
-CREATE_FACTORY(Gravity, CL_FIELD_GRAVITY);
+CREATE_FACTORY(Gravity);
 
 Gravity::Gravity(const TiXmlElement* root)
 {
-  this->setClassID(CL_FIELD_GRAVITY, "Gravity");
+  this->registerObject(this, Gravity::_objectList);
 
   if (root != NULL)
Index: trunk/src/lib/physics/fields/gravity.h
===================================================================
--- trunk/src/lib/physics/fields/gravity.h	(revision 9682)
+++ trunk/src/lib/physics/fields/gravity.h	(revision 9869)
@@ -16,4 +16,5 @@
 //! A class for ...
 class Gravity : public Field {
+  ObjectListDeclaration(Gravity);
 
  public:
Index: trunk/src/lib/physics/fields/point_gravity.cc
===================================================================
--- trunk/src/lib/physics/fields/point_gravity.cc	(revision 9682)
+++ trunk/src/lib/physics/fields/point_gravity.cc	(revision 9869)
@@ -20,4 +20,7 @@
 
 
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(PointGravity, CL_FIELD_POINT_GRAVITY);
+
 
 /**
@@ -27,5 +30,5 @@
 PointGravity::PointGravity ()
 {
-   this->setClassID(CL_FIELD_POINT_GRAVITY, "PointGravity");
+  this->registerObject(this, PointGravity::_objectList);
 }
 
Index: trunk/src/lib/physics/fields/point_gravity.h
===================================================================
--- trunk/src/lib/physics/fields/point_gravity.h	(revision 9682)
+++ trunk/src/lib/physics/fields/point_gravity.h	(revision 9869)
@@ -1,3 +1,3 @@
-/*! 
+/*!
  * @file point_gravity.h
   *  Definition of ...
@@ -16,4 +16,5 @@
 //! A class for ...
 class PointGravity : public Field {
+  ObjectListDeclaration(PointGravity);
 
  public:
Index: trunk/src/lib/physics/fields/twirl.cc
===================================================================
--- trunk/src/lib/physics/fields/twirl.cc	(revision 9682)
+++ trunk/src/lib/physics/fields/twirl.cc	(revision 9869)
@@ -20,4 +20,7 @@
 
 
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Twirl, CL_FIELD_TWIRL);
+
 
 /**
@@ -27,5 +30,5 @@
 Twirl::Twirl ()
 {
-   this->setClassID(CL_FIELD_TWIRL, "Twirl");
+  this->registerObject(this, Twirl::_objectList);
 }
 
Index: trunk/src/lib/physics/fields/twirl.h
===================================================================
--- trunk/src/lib/physics/fields/twirl.h	(revision 9682)
+++ trunk/src/lib/physics/fields/twirl.h	(revision 9869)
@@ -1,3 +1,3 @@
-/*! 
+/*!
  * @file twirl.h
   *  Definition of ...
@@ -16,4 +16,5 @@
 //! A class for ...
 class Twirl : public Field {
+  ObjectListDeclaration(Twirl);
 
  public:
Index: trunk/src/lib/physics/physics_connection.cc
===================================================================
--- trunk/src/lib/physics/physics_connection.cc	(revision 9682)
+++ trunk/src/lib/physics/physics_connection.cc	(revision 9869)
@@ -19,7 +19,8 @@
 
 #include "physics_engine.h"
+#include "debug.h"
 
-#include "field.h"
-#include "particle_system.h"
+#include "fields/field.h"
+#include "particles/particle_system.h"
 #include "physics_interface.h"
 
@@ -27,8 +28,7 @@
 #include "util/loading/load_param.h"
 
-
-
-CREATE_FACTORY(PhysicsConnection, CL_PHYSICS_CONNECTION);
-
+#include "class_id_DEPRECATED.h"
+ObjectListDefinition(PhysicsConnection);
+CREATE_FACTORY(PhysicsConnection);
 /**
  *  creates a PhysicsConnection
@@ -36,5 +36,5 @@
 PhysicsConnection::PhysicsConnection(PhysicsInterface* subject, Field* field)
 {
-  this->setClassID(CL_PHYSICS_CONNECTION, "PhysicsConnection");
+  this->registerObject(this, PhysicsConnection::_objectList);
   this->type = PCON_PhysIField;
 
@@ -47,5 +47,5 @@
 PhysicsConnection::PhysicsConnection(const TiXmlElement* root)
 {
-  this->setClassID(CL_PHYSICS_CONNECTION, "PhysicsConnection");
+  this->registerObject(this, PhysicsConnection::_objectList);
   this->type = PCON_PhysIField;
 
Index: trunk/src/lib/physics/physics_connection.h
===================================================================
--- trunk/src/lib/physics/physics_connection.h	(revision 9682)
+++ trunk/src/lib/physics/physics_connection.h	(revision 9869)
@@ -27,5 +27,5 @@
 class PhysicsConnection : public BaseObject
 {
-
+  ObjectListDeclaration(PhysicsConnection);
  public:
   PhysicsConnection(PhysicsInterface* subject, Field* field);
Index: trunk/src/lib/physics/physics_engine.cc
===================================================================
--- trunk/src/lib/physics/physics_engine.cc	(revision 9682)
+++ trunk/src/lib/physics/physics_engine.cc	(revision 9869)
@@ -18,18 +18,16 @@
 #include "physics_engine.h"
 
-#include "class_list.h"
-#include "parser/tinyxml/tinyxml.h"
 #include "util/loading/factory.h"
-#include "util/loading/load_param.h"
-
-
-
-
-/**
- *  standard constructor
-*/
+#include "util/loading/load_param_xml.h"
+
+
+
+ObjectListDefinition(PhysicsEngine);
+/**
+ * @brief standard constructor
+ */
 PhysicsEngine::PhysicsEngine()
 {
-  this->setClassID(CL_PHYSICS_ENGINE, "PhysicsEngine");
+  this->registerObject(this, PhysicsEngine::_objectList);
   this->setName("PhysicsEngine");
   this->interfaces = NULL;
@@ -130,6 +128,5 @@
 PhysicsInterface* PhysicsEngine::getPhysicsInterfaceByName(const std::string& physicsInterfaceName) const
 {
-  BaseObject* interface = ClassList::getObject(physicsInterfaceName, CL_PHYSICS_INTERFACE);
-  return (interface != NULL)?  dynamic_cast<PhysicsInterface*>(interface) : NULL;
+  return PhysicsInterface::objectList().getObject(physicsInterfaceName);
 }
 
@@ -223,10 +220,10 @@
 
   /* actually tick all the PhysicsInterfaces. Move the objects around */
-  if (this->interfaces != NULL || (this->interfaces = ClassList::getList(CL_PHYSICS_INTERFACE)) != NULL)
-  {
-    std::list<BaseObject*>::const_iterator tickPhys;
-    for (tickPhys = this->interfaces->begin(); tickPhys != this->interfaces->end(); tickPhys++)
-      dynamic_cast<PhysicsInterface*>(*tickPhys)->tickPhys(dt);
-  }
+
+  ObjectList<PhysicsInterface>::const_iterator it;
+  for (it = PhysicsInterface::objectList().begin();
+       it != PhysicsInterface::objectList().end();
+       ++it)
+      (*it)->tickPhys(dt);
 }
 
Index: trunk/src/lib/physics/physics_engine.h
===================================================================
--- trunk/src/lib/physics/physics_engine.h	(revision 9682)
+++ trunk/src/lib/physics/physics_engine.h	(revision 9869)
@@ -12,5 +12,5 @@
 #include "physics_connection.h"
 #include "physics_interface.h"
-#include "field.h"
+#include "fields/field.h"
 #include <list>
 
@@ -20,7 +20,8 @@
 
 //! A class, that brings things into motion through Physics.
-class PhysicsEngine : public BaseObject {
-
- public:
+class PhysicsEngine : public BaseObject
+{
+  ObjectListDeclaration(PhysicsEngine);
+public:
   virtual ~PhysicsEngine();
   /** @returns a Pointer to the only object of this Class */
@@ -46,8 +47,8 @@
   void                   debug() const;
 
- private:
+private:
   PhysicsEngine();
 
- private:
+private:
   static PhysicsEngine*         singletonRef;         //!< the singleton reference of the PhysicsEngine
 
Index: trunk/src/lib/physics/physics_interface.cc
===================================================================
--- trunk/src/lib/physics/physics_interface.cc	(revision 9682)
+++ trunk/src/lib/physics/physics_interface.cc	(revision 9869)
@@ -23,5 +23,5 @@
 #include "physics_engine.h"
 
-#include "field.h"
+#include "fields/field.h"
 #include "p_node.h"
 
@@ -31,11 +31,11 @@
 
 
-
+ObjectListDefinition(PhysicsInterface);
 /**
- *  standard constructor
+ * @brief standard constructor
  */
 PhysicsInterface::PhysicsInterface ()
 {
-  this->setClassID(CL_PHYSICS_INTERFACE, "PhysicsInterface");
+  this->registerObject(this, PhysicsInterface::_objectList);
 
   this->mass = 1;
Index: trunk/src/lib/physics/physics_interface.h
===================================================================
--- trunk/src/lib/physics/physics_interface.h	(revision 9682)
+++ trunk/src/lib/physics/physics_interface.h	(revision 9869)
@@ -29,4 +29,5 @@
 class PhysicsInterface : virtual public BaseObject
 {
+  ObjectListDeclaration(PhysicsInterface);
  public:
   PhysicsInterface();
Index: trunk/src/lib/script_engine/Makefile.am
===================================================================
--- trunk/src/lib/script_engine/Makefile.am	(revision 9682)
+++ trunk/src/lib/script_engine/Makefile.am	(revision 9869)
@@ -16,6 +16,7 @@
                 script_manager.cc \
 		script_class.cc \
-		script_method.cc
-		
+		script_method.cc \
+		executor_lua_state.cc
+
 AM_CPPFLAGS= @LUA_INCLUDES@
 
@@ -25,5 +26,6 @@
                 script_manager.h \
 		script_class.h \
-		script_method.h
+		script_method.h \
+		executor_lua_state.h
 
 
Index: trunk/src/lib/script_engine/executor_lua_state.cc
===================================================================
--- trunk/src/lib/script_engine/executor_lua_state.cc	(revision 9869)
+++ trunk/src/lib/script_engine/executor_lua_state.cc	(revision 9869)
@@ -0,0 +1,28 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: ...
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "executor_lua_state.h"
+
+#include "lunar.h"
+
+std::string temp[7];
+
+
+template<typename type> type fromLua(lua_State* state, int index) { type *obj = Lunar<type>::check(state, 1); lua_remove(state, 1); return obj; };
+template<typename type> void toLua(lua_State* state, type value) { Lunar<type>::push(state, value, false); };
+
+template<> const std::string& fromLua<const std::string&>(lua_State* state, int index) { temp[index] = lua_tostring(state, index); return temp[index]; };
Index: trunk/src/lib/script_engine/executor_lua_state.h
===================================================================
--- trunk/src/lib/script_engine/executor_lua_state.h	(revision 9869)
+++ trunk/src/lib/script_engine/executor_lua_state.h	(revision 9869)
@@ -0,0 +1,105 @@
+/*!
+ * @file executor_lua_state.h
+ * Definition of a Executor that takes lua_State* as input.
+ */
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+
+
+#ifndef __EXECUTOR_LUA_STATE_H_
+#define __EXECUTOR_LUA_STATE_H_
+
+
+#include "executor/executor_generic.h"
+
+#include "luaincl.h"
+
+#ifdef FUNCTOR_CALL_TYPE
+ #undef FUNCTOR_CALL_TYPE
+#endif
+//! Define the Functor call type as lua_State*.
+#define FUNCTOR_CALL_TYPE lua_State*
+
+/**
+ * @brief Converts a lua_State into any type.
+ * @param state the State to get the value from.
+ * @param index the position inside of the lua_State to get the value from.
+ * @returns The value if found.
+ */
+template<typename type> type fromLua(lua_State* state, int index);
+/** @see template<typename type> inline type fromLua(lua_State* state, int index) */
+template<> inline bool fromLua<bool>(lua_State* state, int index) { return lua_toboolean(state, index); };
+/** @see template<typename type> inline type fromLua(lua_State* state, int index) */
+template<> inline int fromLua<int>(lua_State* state, int index) { return (int)lua_tonumber(state, index); };
+/** @see template<typename type> inline type fromLua(lua_State* state, int index) */
+template<> inline unsigned int fromLua<unsigned int>(lua_State* state, int index) { return (unsigned int)lua_tonumber(state, index); };
+/** @see template<typename type> inline type fromLua(lua_State* state, int index) */
+template<> inline float fromLua<float>(lua_State* state, int index) { return (float)lua_tonumber(state, index); };
+/** @see template<typename type> inline type fromLua(lua_State* state, int index) */
+template<> inline char fromLua<char>(lua_State* state, int index) { return (char)lua_tonumber(state, index); };
+/** @see template<typename type> inline type fromLua(lua_State* state, int index) */
+template<> const std::string& fromLua<const std::string&>(lua_State* state, int index);
+
+
+/**
+ * @brief writes a value into a lua_State.
+ * @param state the state to write into.
+ * @param value the Value of type to write into the State.
+ */
+template<typename type> void toLua(lua_State* state, type value);
+/** @see template<typename type> void toLua(lua_State* state, type value) */
+template<> inline void toLua<bool>(lua_State* state, bool value) { lua_pushboolean(state, (int) value); };
+/** @see template<typename type> void toLua(lua_State* state, type value) */
+template<> inline void toLua<int>(lua_State* state, int value)  { lua_pushnumber(state, (lua_Number) value); };
+/** @see template<typename type> void toLua(lua_State* state, type value) */
+template<> inline void toLua<unsigned int>(lua_State* state, unsigned int value){ lua_pushnumber(state, (lua_Number) value); };
+/** @see template<typename type> void toLua(lua_State* state, type value) */
+template<> inline void toLua<float>(lua_State* state, float value) { lua_pushnumber(state, (lua_Number) value); };
+/** @see template<typename type> void toLua(lua_State* state, type value) */
+template<> inline void toLua<char>(lua_State* state, char value) { lua_pushnumber(state, (lua_Number) value); };
+/** @see template<typename type> void toLua(lua_State* state, type value) */
+template<> inline void toLua<const std::string&>(lua_State* state, const std::string& value) { lua_pushstring (state, value.c_str()); }
+
+
+
+//! A Class, that evaluates a lua_State and converts indices into different Types.
+template<> class ExecutorEvaluater <lua_State*>
+{
+public:
+  /** @brief Executes the Evaluater
+   * @param CallValue the Value that should be converted
+   * @param defaults the default Values.
+   */
+  template <typename ToType, int index>
+  static ToType getValue(lua_State*& CallValue, const MultiType* const defaults)
+  {
+    return (fromLua<ToType>(CallValue, index+1));
+  }
+  /**
+   * @param state the state to write into
+   * @param value the Value to write there.
+   */
+  template <typename FromType>
+  static void storeRet(lua_State*& state, FromType value)
+  {
+    toLua<FromType>(state, value);
+  }
+  /** @returns the Null Value of a lua_State*, namely (pointer-type) NULL */
+  static lua_State*& defaultValue() { static lua_State* nullState; return nullState; };
+};
+
+#endif /* __EXECUTOR_LUA_STATE_H_ */
Index: trunk/src/lib/script_engine/lunar.h
===================================================================
--- trunk/src/lib/script_engine/lunar.h	(revision 9682)
+++ trunk/src/lib/script_engine/lunar.h	(revision 9869)
@@ -16,5 +16,5 @@
   userdataType;
 public:
-  typedef Executor* mfp;
+  typedef Executor<lua_State*>* mfp;
   typedef struct { const char *name; mfp mfunc; }
   RegType;
@@ -184,8 +184,7 @@
     lua_remove(L, 1);  // remove self so member function args start at index 1
     // get member function from upvalue
-    Executor *l = static_cast<Executor*>(lua_touserdata(L, lua_upvalueindex(1)));
-    int value;
-    (*l)(obj, value, L);  // call member function
-    return value;
+    mfp l = static_cast<mfp>(lua_touserdata(L, lua_upvalueindex(1)));
+    (*l)(obj, L);  // call member function
+    return l->hasRetVal()? 1 : 0;
   }
 
